# SPDX-License-Identifier: GPL-2.0+
-# Grab our configured image. The source for this is found at:
-# https://source.denx.de/u-boot/gitlab-ci-runner
-image: trini/u-boot-gitlab-ci-runner:focal-20220113-03Feb2022
+# Grab our configured image. The source for this is found
+# in the u-boot tree at tools/docker/Dockerfile
+image: trini/u-boot-gitlab-ci-runner:jammy-20230126-17Feb2023
# We run some tests in different order, to catch some failures quicker.
stages:
stage: test.py
before_script:
# Clone uboot-test-hooks
+ - git config --global --add safe.directory "${CI_PROJECT_DIR}"
- git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
- ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
- ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
script:
# If we've been asked to use clang only do one configuration.
- export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
+ - echo BUILD_ENV ${BUILD_ENV}
+ - if [ -n "${BUILD_ENV}" ]; then
+ export ${BUILD_ENV};
+ fi
- tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
--board ${TEST_PY_BD} ${OVERRIDE}
- cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
stage: world build
script:
- ret=0;
- ./tools/buildman/buildman -o /tmp -P -E -W arm -x aarch64 || ret=$?;
+ git config --global --add safe.directory "${CI_PROJECT_DIR}";
+ ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
if [[ $ret -ne 0 ]]; then
./tools/buildman/buildman -o /tmp -seP;
exit $ret;
script:
- virtualenv -p /usr/bin/python3 /tmp/venv
- . /tmp/venv/bin/activate
- - pip install pyelftools
- ret=0;
- ./tools/buildman/buildman -o /tmp -P -E -W aarch64 || ret=$?;
+ git config --global --add safe.directory "${CI_PROJECT_DIR}";
+ ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
if [[ $ret -ne 0 ]]; then
./tools/buildman/buildman -o /tmp -seP;
exit $ret;
stage: world build
script:
- ret=0;
+ git config --global --add safe.directory "${CI_PROJECT_DIR}";
./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
if [[ $ret -ne 0 ]]; then
./tools/buildman/buildman -o /tmp -seP;
stage: world build
script:
- ret=0;
- ./tools/buildman/buildman -o /tmp -P -E -W -x arm,powerpc || ret=$?;
+ git config --global --add safe.directory "${CI_PROJECT_DIR}";
+ ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
if [[ $ret -ne 0 ]]; then
./tools/buildman/buildman -o /tmp -seP;
exit $ret;
fi;
-check for migrated symbols in board header:
+check for new CONFIG symbols outside Kconfig:
stage: testsuites
script:
- - KSYMLST=`mktemp`;
- KUSEDLST=`mktemp`;
- cat `find . -name "Kconfig*"` |
- sed -n -e 's/^\s*config *\([A-Za-z0-9_]*\).*$/CONFIG_\1/p'
- -e 's/^\s*menuconfig *\([A-Za-z0-9_]*\).*$/CONFIG_\1/p'
- | sort -u > $KSYMLST;
- for CFG in `find include/configs -name "*.h"`; do
- grep '#define[[:blank:]]CONFIG_' $CFG |
- sed -n 's/#define.\(CONFIG_[A-Za-z0-9_]*\).*/\1/p' |
- sort -u > ${KUSEDLST} || true;
- NUM=`comm -12 --total --output-delimiter=, ${KSYMLST} ${KUSEDLST} |
- cut -d , -f 3`;
- if [[ $NUM -ne 0 ]]; then
- echo "Unmigrated symbols found in $CFG";
- exit 1;
- fi;
- done
+ - git config --global --add safe.directory "${CI_PROJECT_DIR}"
+ # If grep succeeds and finds a match the test fails as we should
+ # have no matches.
+ - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
+ :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
+ :^include/linux/kconfig.h :^tools/ && exit 1 || exit 0
# QA jobs for code analytics
# static code analysis with cppcheck (we can add --enable=all later)
# search for HACK within source tree and ignore HACKKIT board
- grep -r HACK . | grep -v HACKKIT
-# build HTML documentation
-htmldocs:
+# build documentation
+docs:
stage: testsuites
script:
- virtualenv -p /usr/bin/python3 /tmp/venvhtml
- . /tmp/venvhtml/bin/activate
- pip install -r doc/sphinx/requirements.txt
- make htmldocs
+ - make infodocs
# some statistics about the code base
sloccount:
Check for configs without MAINTAINERS entry:
stage: testsuites
script:
- - if [ `./tools/genboardscfg.py -f 2>&1 | wc -l` -ne 0 ]; then exit 1; fi
+ - ./tools/buildman/buildman -R
# Ensure host tools build
Build tools-only:
script:
- git config --global user.name "GitLab CI Runner";
+ git config --global --add safe.directory "${CI_PROJECT_DIR}";
export USER=gitlab;
virtualenv -p /usr/bin/python3 /tmp/venv;
. /tmp/venv/bin/activate;
export UBOOT_TRAVIS_BUILD_DIR=/tmp/sandbox_spl;
export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
+ set +e;
./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
--board sandbox_spl;
+ set -e;
./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
./tools/buildman/buildman -t;
./tools/dtoc/dtoc -t;
Run tests for Nokia RX-51 (aka N900):
stage: testsuites
script:
- - export PATH=/opt/gcc-11.1.0-nolibc/arm-linux-gnueabi/bin:$PATH;
+ - mkdir nokia_rx51_tmp;
+ ln -s /opt/nokia/u-boot-gen-combined nokia_rx51_tmp/;
+ ln -s /opt/nokia/qemu-n900.tar.gz nokia_rx51_tmp/;
+ ln -s /opt/nokia/kernel_2.6.28-20103103+0m5_armel.deb nokia_rx51_tmp/;
+ ln -s /opt/nokia/libc6_2.5.1-1eglibc27+0m5_armel.deb nokia_rx51_tmp/;
+ ln -s /opt/nokia/busybox_1.10.2.legal-1osso30+0m5_armel.deb nokia_rx51_tmp/;
+ ln -s /opt/nokia/qemu-system-arm nokia_rx51_tmp/;
+ export PATH=/opt/gcc-12.2.0-nolibc/arm-linux-gnueabi/bin:$PATH;
test/nokia_rx51_test.sh
+# Check for any pylint regressions
+Run pylint:
+ stage: testsuites
+ script:
+ - git config --global --add safe.directory "${CI_PROJECT_DIR}"
+ - pip install -r test/py/requirements.txt
+ - pip install asteval pylint==2.12.2 pyopenssl
+ - export PATH=${PATH}:~/.local/bin
+ - echo "[MASTER]" >> .pylintrc
+ - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
+ - export UBOOT_TRAVIS_BUILD_DIR=/tmp/sandbox_spl
+ - set +e
+ - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
+ --board sandbox_spl
+ - set -e
+ - pylint --version
+ - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
+ - make pylint_err
+
+# Check for pre-schema driver model tags
+Check for pre-schema tags:
+ stage: testsuites
+ script:
+ - git config --global --add safe.directory "${CI_PROJECT_DIR}";
+ # If grep succeeds and finds a match the test fails as we should
+ # have no matches.
+ - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
+
# Test sandbox with test.py
sandbox test.py:
variables:
sandbox with clang test.py:
variables:
TEST_PY_BD: "sandbox"
- OVERRIDE: "-O clang-13"
+ OVERRIDE: "-O clang-14"
+ <<: *buildman_and_testpy_dfn
+
+sandbox without LTO test.py:
+ variables:
+ TEST_PY_BD: "sandbox"
+ BUILD_ENV: "NO_LTO=1"
<<: *buildman_and_testpy_dfn
sandbox_spl test.py:
TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
<<: *buildman_and_testpy_dfn
+sandbox_vpl test.py:
+ variables:
+ TEST_PY_BD: "sandbox_vpl"
+ TEST_PY_TEST_SPEC: "test_vpl_help or test_spl"
+ <<: *buildman_and_testpy_dfn
+
+# Enable tracing and disable LTO, to ensure functions are not elided
+sandbox trace_test.py:
+ variables:
+ TEST_PY_BD: "sandbox"
+ BUILD_ENV: "FTRACE=1 NO_LTO=1"
+ TEST_PY_TEST_SPEC: "trace"
+ OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000"
+ <<: *buildman_and_testpy_dfn
+
evb-ast2500 test.py:
variables:
TEST_PY_BD: "evb-ast2500"
TEST_PY_ID: "--id qemu"
<<: *buildman_and_testpy_dfn
+evb-ast2600 test.py:
+ variables:
+ TEST_PY_BD: "evb-ast2600"
+ TEST_PY_ID: "--id qemu"
+ <<: *buildman_and_testpy_dfn
+
sandbox_flattree test.py:
variables:
TEST_PY_BD: "sandbox_flattree"